/*
   ADF4351 example program
*/

#include <Arduino.h>
#include "adf4351.h"

#include <LiquidCrystal_I2C.h>

// initialize the library with the numbers of the interface pins
LiquidCrystal_I2C lcd(0x27, 16, 2);

#define SWVERSION "1.0"

#define PIN_SS 9  ///< SPI slave select pin, default value
// MON 0 以下だったら　"MON     "　を表示
#define MON_0 0   
// MON 0 以上 MON 20 以下だったら　"MON1    "　を表示
#define MON_S1MIN 20
// MON 21 以上 MON 40 以下だったら　"MON12   "　を表示
#define MON_S12MIN 21
#define MON_S12MAX 40
// MON 41 以上 MON 60 以下だったら　"MON123  "　を表示
#define MON_S123MIN 41
#define MON_S123MAX 60
// MON 61 以上 MON 80 以下だったら　"MON1234 "　を表示
#define MON_S1234MIN 61
#define MON_S1234MAX 80
// MON 80 以上 MON 100 以下だったら　"MON12345"　を表示
#define MON_S12345MIN 81
#define MON_S12345MAX 100
// MON 100 以上 "MON12345"　を表示
#define MON_S12345OVR 100

// TMP 0 以下だったら　"TMP     "　を表示
#define TMP_0 0   
// TMP 0 以上 TMP 20 以下だったら　"TMP1    "　を表示
#define TMP_S1MIN 20
// TMP 21 以上 TMP 40 以下だったら　"TMP12   "　を表示
#define TMP_S12MIN 21
#define TMP_S12MAX 40
// TMP 41 以上 TMP 60 以下だったら　"TMP123  "　を表示
#define TMP_S123MIN 41
#define TMP_S123MAX 60
// TMP 61 以上 TMP 80 以下だったら　"TMP1234 "　を表示
#define TMP_S1234MIN 61
#define TMP_S1234MAX 80
// TMP 80 以上 "TMP12345"　を表示
#define TMP_S12345MIN 81
#define TMP_S12345MAX 100
// TMP 100 以上 "TMP12345"　を表示
// アラート発出 液晶１行目 "TMP HIGH"　を表示
#define TMP_S12345OVR 100
// IF 100 以上 " IF HIGH"　を表示
// アラート発出 液晶１行目 " IF HIGH"　を表示
#define IF_HIGH 100


ADF4351  vfo(PIN_SS, SPI_MODE0, 1000000UL , MSBFIRST) ;

unsigned long TX_Microwave_On_Delay = 100;
unsigned long TX_Microwave_Delay_On_Last = 0;
unsigned long TX_Microwave_Off_Delay = 100;
unsigned long TX_Microwave_Delay_Off_Last = 0;

boolean flag3 = false;    
boolean flag4 = false;    
boolean flag5 = true;    

boolean flag = true;
boolean flag2 = true;
boolean iflow = false;
boolean ifhigh = false;
boolean tmphigh = false;
void (* resetF)(void) = 0;
int value;
int value2;
int value3;
int state = 0;
uint32_t gfreq;
double volt;
const int VOL_PIN = A2;
const int VOL_PIN2 = A3;
const int VOL_PIN3 = A6;
void setup()
{
  Serial.begin(9600) ;
  Serial.print("Hello adf4351 demo v") ;
  Serial.println(SWVERSION) ;
  // debug BigNumber::begin (128);         // shinji-y 20221213 added
  Wire.begin() ;
  lcd.init();                // initialize the lcd
  lcd.backlight();           // Turn on backlight 

  /*!
     setup the chip (for a 10 mhz ref freq)
     most of these are defaults
  */
// shinji-y  vfo.pwrlevel = 0 ; ///< sets to -4 dBm output
  vfo.pwrlevel = 0 ; ///< sets to -4dBm output
  vfo.RD2refdouble = 0 ; ///< ref doubler off
  vfo.RD1Rdiv2 = 0 ;   ///< ref divider off
  vfo.ClkDiv = 150 ;
  vfo.BandSelClock = 80 ;
  vfo.RCounter = 1 ;  ///< R counter to 1 (no division)
  vfo.ChanStep = steps[2] ;  ///< set to 10 kHz steps

  /*!
     sets the reference frequency to 10 Mhz
  */
  if ( vfo.setrf(12800000UL) ==  0 )
    Serial.println("ref freq set to 12.8 Mhz") ;
//  if ( vfo.setrf(10000000UL) ==  0 )
//    Serial.println("ref freq set to 10.0 Mhz") ;
  else
    Serial.println("ref freq set error") ;
  /*!
     initialize the chip
  */
  vfo.init() ;
  digitalWrite(PIN_TXOFF, HIGH);
  delay(40);
  digitalWrite(PIN_TXOFF, LOW);
  flag = true;
  /*!
     enable frequency output
  */
  vfo.enable() ;
}



void loop()
{
  /*!
     do a set of freq changes (40 Mhz, 4 GHz, and 1Ghz, )
    delay(5000);
    Serial.println("setf() to 40 MHz") ;

    if ( vfo.setf(40000000UL) == 0 ) {
    Serial.print("setf() success freq:") ;
    Serial.println(vfo.cfreq) ;
    } else {
    Serial.println("setf() error") ;
    }

    delay(5000);
  */
  vfo.curLoopTime = millis();
  // flashes the heartbeat LED
  vfo.Heartbeat();
  CalControl(millis());
  if (flag) {
    Serial.println("setf() to 2109MHz") ;
    if ( vfo.setf(2109000000UL) == 0 ) {   // for 24GHz lo：2109MHz IF：1288MHz
//    if ( vfo.setf(2107000000UL) == 0 ) {   // for 24GHz lo：2107MHz IF：1264MHz
//  if ( vfo.setf(2235000000UL) == 0) {    // Set local oscilater freqency 4480MHz // for 5.6GHz 
//  if ( vfo.setf(4470000000UL) == 0) {    // Set local oscilater freqency 4480MHz // for 5.6GHz 
//  if ( vfo.setf(2983333000 UL) == 0) {   // Set local oscilater freqency 4480MHz for 10GHz its works well ! 23231218
      Serial.print("setf() success freq:") ;
/*      Serial.println(vfo.cfreq) ;
      Serial.print("PLL INT:");
      Serial.println(vfo.N_Int);
      Serial.print("PLL FRAC:");
      Serial.println(vfo.Frac);
      Serial.print("PLL MOD:");
      Serial.println(vfo.Mod);
      Serial.print("PLL PFD:");
      Serial.println(vfo.PFDFreq);
      Serial.print("PLL output divider:");
      Serial.println(vfo.outdiv);
      Serial.print("PLL prescaler:");
      Serial.println(vfo.Prescaler);
      Serial.println("");*/
    } else {
      Serial.println("setf() error") ;
/*      Serial.println(vfo.cfreq) ;
      Serial.print("PLL INT:");
      Serial.println(vfo.N_Int);
      Serial.print("PLL FRAC:");
      Serial.println(vfo.Frac);
      Serial.print("PLL MOD:");
      Serial.println(vfo.Mod);
      Serial.print("PLL PFD:");
      Serial.println(vfo.PFDFreq);
      Serial.print("PLL output divider:");
      Serial.println(vfo.outdiv);
      Serial.print("PLL prescaler:");
      Serial.println(vfo.Prescaler);
      Serial.println("");*/
      
    }
    flag = false;
  } else {        
    if ( digitalRead(PIN_LD) == HIGH && flag2) {
      Serial.println(F("setf() lock enable HIGH okay it locked")) ;
      digitalWrite(PIN_LD_LED, HIGH);
      flag2 = !flag2;
    }
    else if ( digitalRead(PIN_LD) == LOW && flag2) {
      Serial.println(F("setf() Error lock enable LOW Not good UNlocked")) ;
      digitalWrite(PIN_LD_LED, LOW);
      flag2 = !flag2;
    };
  }

    value = analogRead( VOL_PIN );
    value2 = analogRead( VOL_PIN2 );
    value3 = analogRead( VOL_PIN3 );

    volt = value * 5.0 / 1023.0;
    lcd.setCursor(0, 0);  // set the cursor to (0,0) (first column,first row).      
    lcd.print(gfreq / 1000000);    
    lcd.setCursor(4, 0);  // set the cursor to (0,0) (first column,first row).      
    lcd.print("MHz");
    if ( digitalRead(PIN_LD) == HIGH) {
      lcd.setCursor(7, 0);  // set the cursor to (0,0) (first column,first row).      
      lcd.print("*");
      digitalWrite(PIN_LD_LED, HIGH);
    }
    else if ( digitalRead(PIN_LD) == LOW) {
      lcd.setCursor(7, 0);  // set the cursor to (0,0) (first column,first row).      
      lcd.print(" ");
      digitalWrite(PIN_LD_LED, LOW);
    };
    lcd.setCursor(8, 0);  // set the cursor to (0,0) (first column,first row).      
    switch(state){
      case 0:
        lcd.print(" RECIVE ");
        break;
      case 1:
        lcd.print("TMP HIGH");
        break;

      case 2:
        lcd.print("TRANSMIT");
        break;
      case 3:
        lcd.print(" IF HIGH");
        break;      
    };
/*
    lcd.setCursor(0, 0);  // set the cursor to (0,0) (first column,first row).    
    lcd.print( "Val1:" );
    lcd.print( value );
    lcd.print( "Val2:" );
    lcd.print( value2 );
*/
    // lcd.println( volt );    
   if ( vfo.transmitting ){
        displayMON();    
      if ( value3 > IF_HIGH){
         displayLCD();
         state = 3;      
      } else {
         displayLCD();    
         state = 2;
      }
    } else if ( !vfo.transmitting ){
        lcd.setCursor(0, 1);  // set the cursor to (0,1) (first column,second row)
        lcd.print( "MON     " );      
        displayLCD();
        if ( !(state == 1) )
           state = 0;            
    };
    // lcd.println( volt );    
  /*
    delay(5000);
    Serial.println("setf() to 1 GHz") ;

    if ( vfo.setf(1000000000UL) == 0 ) {
      Serial.print("setf() success freq:") ;
      Serial.println(vfo.cfreq) ;
    } else {
      Serial.println("setf() error") ;
    }
  */
  /*!
     change the step value to 100kHz
     do a set of 5 channel steps change every 5 seconds
     1,000.100 Mhz
     1,000.200 Mhz
     ...
     1,000.500 Mhz

     print out the PLL values

  */
  /*
    unsigned long newf ;
    vfo.ChanStep = steps[4] ; ///< change to 100 kHz

    for (int i = 0; i < 5; i++) {
      delay(5000);
      newf = vfo.cfreq + vfo.ChanStep ;

      if ( vfo.setf(newf) == 0 ) {
        Serial.print("setf() success freq:") ;
        Serial.println(vfo.cfreq) ;
      } else {
        Serial.println("setf() error") ;
      }

      Serial.println(vfo.cfreq) ;
      Serial.print("PLL INT:");
      Serial.println(vfo.N_Int);
      Serial.print("PLL FRAC:");
      Serial.println(vfo.Frac);
      Serial.print("PLL MOD:");
      Serial.println(vfo.Mod);
      Serial.print("PLL PFD:");
      Serial.println(vfo.PFDFreq);
      Serial.print("PLL output divider:");
      Serial.println(vfo.outdiv);
      Serial.print("PLL prescaler:");
      Serial.println(vfo.Prescaler);
      Serial.println("");
    }
  */
  /*!
     disable the output for 5 seconds
     and then enable it.
  */
  /*
    delay(5000);
    vfo.disable() ;
    delay(5000);
    vfo.enable() ;
  */
  /*!
     change freq back to 1 Ghz
  */
  /*
    delay(5000);

    if ( vfo.setf(1000000000UL) == 0 ) {
      Serial.print("setf() success freq:") ;
      Serial.println(vfo.cfreq) ;
    } else {
      Serial.println("setf() error") ;
    }

    delay(5000) ;
  */
}

void displayMON ( void ) {
// MON 0 以下だったら　"MON     "　を表示
// #define MON_0 0   
// MON 0 以上 MON 20 以下だったら　"MON1    "　を表示
// #define MON_S1MIN 20
// MON 21 以上 MON 40 以下だったら　"MON12   "　を表示
// #define MON_S12MIN 21
// #define MON_S12MAX 40
// MON 41 以上 MON 60 以下だったら　"MON123  "　を表示
// #define MON_S123MIN 41
// #define MON_S123MAX 60
// MON 61 以上 MON 80 以下だったら　"MON1234 "　を表示
// #define MON_S1234MIN 61
// #define MON_S1234MAX 80
// MON 80 以上 "MON12345"　を表示
// #define MON_S12345MAX 80
// MON 100 以上 "MON12345"　を表示
// #define MON_S12345OVR 100
    lcd.setCursor(0, 1);  // set the cursor to (0,1) (first column,second row)
    if (value <= MON_0){
      lcd.print( "MON     " );      
    }
    else if (value <= MON_S1MIN){
      lcd.print( "MON1    " );            
    }
// #define MON_S12MIN 21
// #define MON_S12MAX 40
    else if (value >= MON_S12MIN && value <= MON_S12MAX){
      lcd.print( "MON12   " );            
    }
// #define MON_S123MIN 41
// #define MON_S123MAX 60
    else if (value >= MON_S123MIN && value <= MON_S123MAX){
      lcd.print( "MON123  " );            
    }
// #define MON_S1234MIN 61
// #define MON_S1234MAX 80
    else if (value >= MON_S1234MIN &&value <= MON_S1234MAX){
      lcd.print( "MON1234 " );            
    }
#define MON_S12345MIN 81
#define MON_S12345MAX 100
    else if (value >= MON_S12345MIN &&value <= MON_S12345MAX){
      lcd.print( "MON12345" );            
// #define MON_S12345OVR 100
    } else if ( value > MON_S12345OVR ) {
      lcd.print( "MON12345" );            
      if ( value3 > IF_HIGH ){
         state = 3;      
      }
    };  
}

void displayLCD ( void ){
// TMP 0 以下だったら　"TMP     "　を表示
// #define TMP_0 0   
// TMP 0 以上 TMP 20 以下だったら　"TMP1    "　を表示
// #define TMP_S1MIN 20
// TMP 21 以上 TMP 40 以下だったら　"TMP12   "　を表示
// #define TMP_S12MIN 21
// #define TMP_S12MAX 40
// TMP 41 以上 TMP 60 以下だったら　"TMP123  "　を表示
// #define TMP_S123MIN 41
// #define TMP_S123MAX 60
// TMP 61 以上 TMP 80 以下だったら　"TMP1234 "　を表示
// #define TMP_S1234MIN 61
// #define TMP_S1234MAX 80
// TMP 80 以上 "TMP12345"　を表示
// #define TMP_S12345MAX 80
// TMP 100 以上 "TMP12345"　を表示
// アラート発出 液晶１行目 "TMP HIGH"　を表示
// #define TMP_S12345OVR 100
    lcd.setCursor(8, 1);  // set the cursor to (0,1) (first column,second row)
// #define TMP_0 0   
      if (value2 <= TMP_0){
      tmphigh = false;
      if (!iflow && !ifhigh)
        state = 0;
      lcd.print( "TMP     " );      
    }
// #define TMP_S1MIN 20
    else if (value2 <= TMP_S1MIN){
      tmphigh = false;
      lcd.print( "TMP1    " );            
      if (!iflow && !ifhigh)
        state = 0;
    }
// #define TMP_S12MIN 21
// #define TMP_S12MAX 40
    else if (value2 >= TMP_S12MIN && value2 <= TMP_S12MAX){
      tmphigh = false;
      if (!iflow && !ifhigh)
        state = 0;
      lcd.print( "TMP12   " );            
    }
// #define TMP_S123MIN 41
// #define TMP_S123MAX 60
    else if (value2 >= TMP_S123MIN && value2 <= TMP_S123MAX){
      tmphigh = false;
      if (!iflow && !ifhigh )
        state = 0;
      lcd.print( "TMP123  " );            
    }
// #define TMP_S1234MIN 61
// #define TMP_S1234MAX 80
    else if (value2 >= TMP_S1234MIN &&value2 <= TMP_S1234MAX){
      tmphigh = false;
      if (!iflow && !ifhigh )
        state = 0;
      lcd.print( "TMP1234 " );            
    }
// #define TMP_S12345MIN 81
// #define TMP_S12345MAX 100
    else if (value2 >= TMP_S12345MIN &&value2 <= TMP_S12345MAX){
      tmphigh = true;
      if (!iflow && !ifhigh && tmphigh)
        state = 0;
      lcd.print( "TMP12345" );            
// #define TMP_S12345OVR 100
    } else if (value2 > TMP_S12345OVR){
      tmphigh = true;
      if (!iflow && !ifhigh && tmphigh)
        state = 1;
      lcd.print( "TMP12345" );            
    };
}

void CalControl(unsigned long CurrentTime)
{
/*  
初期値：
boolean flag3 = false;    <- キャリアコントロール on で true
boolean flag4 = false;    <- キャリアコントロール off で true
boolean flag5 = false;    <- キャリアコントロール on ディレイタイム中 で true

キャリアコントロール == LOW && !flag3 && !flag4 && flag5： <- 条件判断 キャリアコントロール on
処理：
flag3 = true;    <- キャリアコントロール on で true
flag5 = true;    <- キャリアコントロール on ディレイタイム中 で true

キャリアコントロール == HIGH && flag3 && !flag4 && !flag5： <- 条件判断 キャリアコントロール off
処理：
flag4 = true;    <- キャリアコントロール off で true
flag5 = false;    <- キャリアコントロール on ディレイタイム中 で true

ディレイタイム以内 && flag3 && !flag4 && flag5: <- 条件判断 マイクロ波リレー　On　ディレイタイム以内
処理：
return;

ディレイタイム以内 && flag3 && flag4 && !flag5: <- 条件判断 マイクロ波リレー　Off　ディレイタイム以内  
処理：
return;

キャリアコントロール == LOW && flag3 && !flag4 && flag5: <- 条件判断 キャリアコントロール on タイムアウト
処理：
flag3 = false;    <- キャリアコントロール on で true
flag4 = true;    <- キャリアコントロール off で true
flag5 = false;    <- キャリアコントロール on ディレイタイム中 で true


キャリアコントロール == HIGH !flag3 && flag4 && !flag5: <- 条件判断 キャリアコントロール off タイムアウト
flag3 = false;    <- キャリアコントロール on で true
flag4 = false;    <- キャリアコントロール off で true
flag5 = false;    <- キャリアコントロール on ディレイタイム中 で true

 */
  if ( digitalRead(PIN_M5DT) == HIGH && digitalRead(PIN_CAL_CTL) == LOW && !flag3 && !flag4 && flag5) {
      TX_Microwave_Delay_On_Last = millis();
      Serial.println("Micro wave relay TX side") ;
      digitalWrite(PIN_MRC, HIGH);  
      digitalWrite(PIN_TXON, HIGH);
      delay(40);
      digitalWrite(PIN_TXON, LOW);
      flag3 = true;
  };
// マイナス５V喪失かつ送信状態だったらアラート発出かつ TX_A , TX_B +5V or +6V OFF
  if ( digitalRead(PIN_M5DT) == LOW && digitalRead(PIN_CAL_CTL) == LOW && !flag3 && flag4 && !flag5) {
      digitalWrite(PIN_TXC, LOW);  
      TX_Microwave_Delay_Off_Last = millis();
      Serial.println("ALERT : Lost minus 5 volts , TX_A , TX_B +5V or +6V OFF");
      flag5 = true;
  };
  if ( digitalRead(PIN_CAL_CTL) == HIGH && !flag3 && flag4 && !flag5) {
      TX_Microwave_Delay_Off_Last = millis();
      Serial.println("TX_A , TX_B +5V or +6V OFF");
      digitalWrite(PIN_TXC, LOW);  
      vfo.transmitting = false;
      flag5 = true;
  };
  if (((CurrentTime - TX_Microwave_Delay_On_Last) < TX_Microwave_On_Delay) && flag3 && !flag4 && flag5)
  {
    return; // in delay time マイクロ波リレー　On　ディレイタイム以内
  };
  if ((CurrentTime - TX_Microwave_Delay_Off_Last) < TX_Microwave_Off_Delay && !flag3 && flag4 && flag5){
    return; // in delay time マイクロ波リレー　Off　ディレイタイム以内  
  };
  if ( digitalRead(PIN_CAL_CTL) == LOW && !flag3 && !flag4 && !flag5) {
    flag3 = false;
    flag4 = false;
    flag5 = true;
    return; // アイドルタイム　受信待受
  };
  // TX_Microwave_Delay_On or TX_Microwave_Delay_On overflow　タイムアウト
  if ( digitalRead(PIN_M5DT) == HIGH && digitalRead(PIN_CAL_CTL) == LOW && flag3 && !flag4 && flag5) {   // TX_Microwave_Delay_On タイムアウト
      Serial.println("TX_A , TX_B +5V or +6V ON");
      digitalWrite(PIN_TXC, HIGH); // TX_A , TX_B +5V or +6V ON
      flag3 = false;
      flag4 = true;
      flag5 = false;
      vfo.transmitting = true;
    };
  if ( digitalRead(PIN_CAL_CTL) == HIGH && !flag3 && flag4 && flag5) {   // TX_Microwave_Delay_Off タイムアウト
      Serial.println("Micro wave relay RX side") ;
      digitalWrite(PIN_MRC, LOW);
      digitalWrite(PIN_TXOFF, HIGH);
      delay(40);
      digitalWrite(PIN_TXOFF, LOW);
      flag3 = false;
      flag4 = false;
      flag5 = true;
    };
  
}
